//silnik 1
#define out1 13
#define out2 12
//silnik 2
#define out3 10
#define out4 11
//silnik 3
#define out5 9
#define out6 8
//silnik 4
#define out7 6
#define out8 7
//obroty silnika
#define PWM 3
//czujnik 1
#define S0 A0
#define S1 A1
#define S2 A3
#define S3 A2
#define sensorOut A4
//czujnik 2
#define S00 A6
#define S01 A7
#define S02 4
#define S03 5
#define sensor 2

void setup() {
  Serial.begin(9600);

  delay(300);

  pinMode(out1, OUTPUT);
  pinMode(out2, OUTPUT);
  pinMode(out3, OUTPUT);
  pinMode(out4, OUTPUT);
  pinMode(out5, OUTPUT);
  pinMode(out6, OUTPUT);
  pinMode(out7, OUTPUT);
  pinMode(out8, OUTPUT);

  pinMode(PWM, OUTPUT);

  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(sensorOut, INPUT);

  pinMode(S00, OUTPUT);
  pinMode(S01, OUTPUT);
  pinMode(S02, OUTPUT);
  pinMode(S03, OUTPUT);
  pinMode(sensor, INPUT);

  digitalWrite(S0, HIGH);
  digitalWrite(S1, LOW);

  digitalWrite(S00, HIGH);
  digitalWrite(S01, LOW);
}

void loop() {
  analogWrite(PWM, 75);//ustawiamy predkosc

  int lewy = zrobPomiar(S2, S3, sensorOut);//wywolujemy funkcje która zrobi nam pomiar dla pierwszego czujnika
  int prawy = zrobPomiar(S02, S03, sensor);//wywolujemy funkcje która zrobi nam pomiar dla drugiego czujnika

  Serial.print("Lewy czujnik: ");
  Serial.print(lewy);
  Serial.print(" Prawy czujnik: ");
  Serial.print(prawy);
  Serial.println();

  if (lewy > 20 && prawy < 17 ) {//jezeli lewy czujnik widzi wartosc powyzej 20 (tasme), a prawy wartosc ponizej 17(biale), to skrec w lewo
    analogWrite(PWM, 85);
    skrecLewo();
  } else if  (lewy < 17 && prawy > 20) {//jezeli lewy czujnik widzi wartosc ponizej 17 (biale), a prawy wartosc powyzej 20(tasme), to skrec w prawo
    analogWrite(PWM, 85);
    skrecPrawo();
  } else {//w przeciwnym wypadku jedz prosto
    jedzDoPrzodu();
  }
}

int zrobPomiar(int x, int y, int z) {
  int frequencyRed = 0, frequencyGreen = 0, frequencyBlue = 0, suma = 0;

  digitalWrite(x, LOW);//x = s2
  digitalWrite(y, LOW);//y = s3

  frequencyRed = pulseIn(z, LOW);//z = out

  digitalWrite(x, HIGH);
  digitalWrite(y, HIGH);

  frequencyGreen = pulseIn(z, LOW);

  digitalWrite(x, LOW);
  digitalWrite(y, HIGH);

  frequencyBlue = pulseIn(z, LOW);

  suma = frequencyRed + frequencyGreen + frequencyBlue;

  return suma;
}

void jedzDoPrzodu() {
  digitalWrite(out1, LOW);
  digitalWrite(out2, HIGH);

  digitalWrite(out3, LOW);
  digitalWrite(out4, HIGH);

  digitalWrite(out5, LOW);
  digitalWrite(out6, HIGH);

  digitalWrite(out7, LOW);
  digitalWrite(out8, HIGH);
}
void skrecLewo() {
  digitalWrite(out1, LOW);
  digitalWrite(out2, HIGH);

  digitalWrite(out3, LOW);
  digitalWrite(out4, HIGH);

  digitalWrite(out5, LOW);
  digitalWrite(out6, LOW);

  digitalWrite(out7, LOW);
  digitalWrite(out8, LOW);
}
void skrecPrawo() {
  digitalWrite(out1, LOW);
  digitalWrite(out2, LOW);

  digitalWrite(out3, LOW);
  digitalWrite(out4, LOW);

  digitalWrite(out5, LOW);
  digitalWrite(out6, HIGH);

  digitalWrite(out7, LOW);
  digitalWrite(out8, HIGH);
}
